#include "cctk.h"
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"
#include "cctk_Functions.h"

subroutine CCCC_StarMapper_Allocate(CCTK_ARGUMENTS)

  use StarMapper_Module
  implicit none

  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS
  DECLARE_CCTK_FUNCTIONS

  integer length


  length = Num_Radial + Num_Spacetime

  allocate(smass(length))
  allocate(sr(length))
  allocate(srho(length))
  allocate(snewtpot(length))
  allocate(smetric(length))
  allocate(salp(length))



end subroutine CCCC_StarMapper_Allocate


subroutine CCCC_StarMapper_DeAllocate(CCTK_ARGUMENTS)

  use StarMapper_Module
  implicit none

  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS
  DECLARE_CCTK_FUNCTIONS

  
  deallocate(smass)
  deallocate(srho)
  deallocate(sr)
  deallocate(snewtpot)  
  deallocate(smetric)  
  deallocate(salp)  


end subroutine CCCC_StarMapper_DeAllocate



