#include "cctk.h"
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"

module StarMapper_Module

   implicit none

   CCTK_INT :: EOS_StarMapperCall

   CCTK_REAL :: eosgeneral_pmin
   
! factors that give CGS*factor=CACTII

   CCTK_REAL,parameter :: press_factor = 1.80171810d-39
   CCTK_REAL,parameter :: length_factor = 6.77140812d-06
   CCTK_REAL,parameter :: time_factor = 2.03001708d5
   CCTK_REAL,parameter :: density_factor = 1.61930347d-18 
   CCTK_REAL,parameter :: mass_factor = 5.02765209d-34
   CCTK_REAL,parameter :: velocity_factor = 3.33564095d-11
   CCTK_REAL,parameter :: specific_internal_energy_factor = 1.11265006d-21
!   CCTK_REAL :: tempfactor = 1.6022d-6

   CCTK_REAL,parameter :: mev_to_erg = 1.6022d-6
   CCTK_REAL,parameter :: kboltz = 1.3806d-16/mev_to_erg

   CCTK_REAL :: gamma1 = 4.0d0/3.0d0
   CCTK_REAL :: eosk = 4.93483302030614e14   ! 1.2435d15 * (0.5d0**(4.d0/3.d0))

   CCTK_INT  :: szones
   CCTK_REAL, allocatable,save :: srho(:)
   CCTK_REAL, allocatable,save :: snewtpot(:)
   CCTK_REAL, allocatable,save :: sr(:)
   CCTK_REAL, allocatable,save :: smass(:)
   CCTK_REAL, allocatable,save :: smetric(:)
   CCTK_REAL, allocatable,save :: salp(:)


 end module StarMapper_Module
