#include "cctk.h"
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"
#include "cctk_Functions.h"

subroutine CCCC_StarMapper_Prim2Con(CCTK_ARGUMENTS)

  use StarMapper_Module

  implicit none

  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS
  DECLARE_CCTK_FUNCTIONS

  integer i,j,k,nx,ny,nz
  CCTK_REAL tenthalpy, w, rdetg
  CCTK_REAL vlowx,vlowy,vlowz
  integer istat


  nx = cctk_lsh(1)
  ny = cctk_lsh(2)
  nz = cctk_lsh(3)

  call CCTK_INFO("Initial Prim2Con")

  istat = 0
  call CCTK_QueryGroupStorage(istat,cctkGH,"hydrobase::Y_e")

  do i=1,nx
     do j=1,ny
        do k=1,nz

           rdetg = sqrt(gxx(i,j,k)**3)
  


           w = 1.0d0 / &
                sqrt(1.0d0 - (gxx(i,j,k)*vel(i,j,k,1)*vel(i,j,k,1) &
                + gyy(i,j,k)*vel(i,j,k,2)*vel(i,j,k,2) &
                + gzz(i,j,k)*vel(i,j,k,3)*vel(i,j,k,3) ) )

           vlowx = gxx(i,j,k)*vel(i,j,k,1) &
                + gxy(i,j,k)*vel(i,j,k,2)  &
                + gxz(i,j,k)*vel(i,j,k,3)
           vlowy = gxy(i,j,k)*vel(i,j,k,1) &
                + gyy(i,j,k)*vel(i,j,k,2)  &
                + gyz(i,j,k)*vel(i,j,k,3)
           vlowz = gxz(i,j,k)*vel(i,j,k,1) &
                + gyz(i,j,k)*vel(i,j,k,2)  &
                + gzz(i,j,k)*vel(i,j,k,3)


           dens(i,j,k) = rdetg*w*rho(i,j,k)

           tenthalpy = 1.0d0 + eps(i,j,k) + press(i,j,k) / rho(i,j,k)

           tau(i,j,k) = rdetg*( (rho(i,j,k)*(1.0d0+eps(i,j,k))+press(i,j,k))*w*w - press(i,j,k)) &
                - dens(i,j,k)

           w_lorentz(i,j,k) = w

           scon(i,j,k,1) = rdetg*rho(i,j,k)*tenthalpy*(w**2) &
                *vlowx
           scon(i,j,k,2) = rdetg*rho(i,j,k)*tenthalpy*(w**2) &
                *vlowy 
           scon(i,j,k,3) = rdetg*rho(i,j,k)*tenthalpy*(w**2) &
                *vlowz


           if(istat.ne.0) then
              Y_e_con(i,j,k) = dens(i,j,k)*Y_e(i,j,k)
           endif


        enddo
     enddo
  enddo

end subroutine 
